G1: Yunli‘s Subarray Queries (easy version)(1900)(定长区间众数)

思路:因为是定长区间,因此我们可以利用滑动窗口维护定长区间的众数的数量

AC代码:

cpp 复制代码
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
const int MOD = 998244353;
const int N = 2e5 + 10;

ll a[N];
ll b[N];//前i个数的相同的数的最大值
int main()
{
	
	int t;
	cin >> t;
	while(t --){
		ll n, k, q;
		cin >> n >> k >> q;
		for(int i = 1; i <= n; i ++)
		{
			cin >> a[i];
			a[i] -= i;
		}
		//求每个区间为k的区间众数的数量
		//看到定长想到滑动区间
		map<ll, ll>ma, cnt;//记录数量
		for(int i = 1; i <= n; i ++)
		{
			if(cnt.count(ma[a[i]]))//相当于对右边界进行操作
			{
				cnt[ma[a[i]]] -= 1;
				if(!cnt[ma[a[i]]]) cnt.erase(ma[a[i]]);
			}
			ma[a[i]] += 1;
			cnt[ma[a[i]]] += 1;
			//前k个数还没到达窗口最远
			if(i < k) continue;
			//因为区间长度已经确定为k了,因此我们确定了左区间,右区间也随之确定了
			b[i - k + 1] = cnt.rbegin() ->first;//代表反向开始的第一个元素,即众数
		//	cout << b[1] << "sss" << endl;
			cnt[ma[a[i - k + 1]]] -= 1;//因为开始窗口滑动了因此也需要考虑左边界了
			if(!cnt[ma[a[i - k + 1]]]) cnt.erase(ma[a[i - k + 1]]);
			ma[a[i - k + 1]]  -= 1;//左边界ma也要参与了
			if(ma[a[i - k + 1]]) cnt[ma[a[i - k + 1]]] += 1;
		}
		while(q --){
			ll l, r;
			cin >> l >> r;
			cout << k - b[l] << endl;
		}
	}
	return 0;
}
相关推荐
yi0116 小时前
LeetCode 219:存在重复元素 II——哈希表记录“最近一次出现的位置”
数据结构·人工智能·笔记·python·算法·leetcode·哈希表
灯澜忆梦8 小时前
【面向对象编程C++】| 基础语法
java·c++·算法
小蒋观天下8 小时前
专项方案:大场景港口AI安防、多干扰环境下的算法调优与落地实操
人工智能·深度学习·算法·安全·机器学习·计算机视觉·ai大模型
Evand J8 小时前
【电机滤波例程5】渐消因子自适应扩展卡尔曼滤波(EKF),MATLAB。PMSM负载突变下的状态估计。附下载链接
算法·matlab
H.莓飛9 小时前
【数据结构】二叉树_OJ题
linux·开发语言·数据结构·算法
好想像大佬一样能够ak所有9 小时前
Leetcode35.搜索插入位置
数据结构·算法·leetcode
aqiu1111119 小时前
【C++算法打怪专栏】LeetCode 165. 比较版本号(双指针与字符串流法)
c++·算法·leetcode
黄金龙PLUS9 小时前
如何基于置换算法来设计对称加密算法
算法·网络安全·密码学·哈希算法·同态加密
不会就选b10 小时前
算法日常・每日刷题--<动态规划>14
算法
赛博守夜人10 小时前
跨境业务与出海合规之九:海外买量投放与营销虚假流量(Ad Fraud):跨国机房群控与归因欺诈识别算法
算法·安全